Index: cpp/frams/_demos/geometry/geometrytestutils.cpp
===================================================================
--- cpp/frams/_demos/geometry/geometrytestutils.cpp	(revision 662)
+++ cpp/frams/_demos/geometry/geometrytestutils.cpp	(revision 732)
@@ -18,17 +18,17 @@
 	long count = 0;
 	long totalSize = 0;
-	MiniGenotypeLoader loader(file);
-	MiniGenotype *genotype;
-	
+	GenotypeMiniLoader loader(file);
+	GenotypeMini *genotype;
+
 	while (genotype = loader.loadNextGenotype())
 	{
 		count++;
 		totalSize += genotype->genotype.len();
-		
+
 		fprintf(stderr, "%d. (%6d chars) %s\n", count, genotype->genotype.len(),
 			genotype->name.c_str());
 	}
-	
-	if (loader.getStatus() == MiniGenotypeLoader::OnError)
+
+	if (loader.getStatus() == GenotypeMiniLoader::OnError)
 	{
 		fprintf(stderr, "Error: %s\n", loader.getError().c_str());
@@ -44,6 +44,6 @@
 class TestInvoker
 {
-	public:
-		virtual void operator()(Model &model) = 0;
+public:
+	virtual void operator()(Model &model) = 0;
 };
 
@@ -53,15 +53,15 @@
 	const int genoIndex = isdigit(genoId[0]) ? atol(genoId) : 0;
 	long count = 0;
-	MiniGenotypeLoader loader(file);
-	MiniGenotype *genotype;
-	
+	GenotypeMiniLoader loader(file);
+	GenotypeMini *genotype;
+
 	while (genotype = loader.loadNextGenotype())
 	{
 		count++;
-		
+
 		if ((genoIndex == count) || (strcmp(genotype->name.c_str(), genoName) == 0))
 		{
 			Model model(genotype->genotype);
-			
+
 			if (!model.isValid())
 			{
@@ -74,6 +74,6 @@
 		}
 	}
-	
-	if (loader.getStatus() == MiniGenotypeLoader::OnError)
+
+	if (loader.getStatus() == GenotypeMiniLoader::OnError)
 	{
 		fprintf(stderr, "Error: %s\n", loader.getError().c_str());
@@ -94,5 +94,5 @@
 	if ((shape < 1) || (shape > 3))
 	{
-		shape = (rand()%3) + 1;
+		shape = (rand() % 3) + 1;
 	}
 
@@ -106,24 +106,24 @@
 }
 
-class ModelBasedTestInvoker: public TestInvoker
-{
-	private:
-		void (*test)(Model &);
-	public:
-		ModelBasedTestInvoker(void (*_test)(Model &)):
-			test(_test)
-		{}
-		void operator()(Model &model)
-		{
-			test(model);
-		}
+class ModelBasedTestInvoker : public TestInvoker
+{
+private:
+	void(*test)(Model &);
+public:
+	ModelBasedTestInvoker(void(*_test)(Model &)) :
+		test(_test)
+	{}
+	void operator()(Model &model)
+	{
+		test(model);
+	}
 };
 
-int GeometryTestUtils::execute(const SString header, int argc, char *argv[], void (*test)(Model &))
+int GeometryTestUtils::execute(const SString header, int argc, char *argv[], void(*test)(Model &))
 {
 	LoggerToStdout messages_to_stdout(LoggerBase::Enable); //comment this object out to mute error/warning messages
 	StdioFileSystem_autoselect stdiofilesys;
 	PreconfiguredGenetics genetics;
-	
+
 	srand(time(NULL));
 
@@ -132,5 +132,5 @@
 		return printGenotypesList(argv[2]);
 	}
-	
+
 	if ((argc == 4) && (strcmp("-l", argv[1]) == 0))
 	{
@@ -138,5 +138,5 @@
 		return executeTestUsingLoadedModel(argv[2], argv[3], invoker);
 	}
-	
+
 	if ((argc == 2) && (strcmp("-c", argv[1]) == 0))
 	{
@@ -144,5 +144,5 @@
 		return executeTestUsingRandomModel(-1, invoker);
 	}
-	
+
 	if ((argc == 3) && (strcmp("-c", argv[1]) == 0) && isdigit(argv[2][0]))
 	{
@@ -151,5 +151,5 @@
 		return executeTestUsingRandomModel(shape, invoker);
 	}
-	
+
 	fprintf(stderr,
 		"%s\n\n"
@@ -165,28 +165,28 @@
 }
 
-class ModelAndDensityBasedTestInvoker: public TestInvoker
-{
-	private:
-		void (*test)(Model &, const double);
-		double density;
-	public:
-		ModelAndDensityBasedTestInvoker(void (*_test)(Model &, const double), double _density):
-			test(_test),
-			density(_density)
-		{}
-		
-		void operator()(Model &model)
-		{
-			test(model, density);
-		}
+class ModelAndDensityBasedTestInvoker : public TestInvoker
+{
+private:
+	void(*test)(Model &, const double);
+	double density;
+public:
+	ModelAndDensityBasedTestInvoker(void(*_test)(Model &, const double), double _density) :
+		test(_test),
+		density(_density)
+	{}
+
+	void operator()(Model &model)
+	{
+		test(model, density);
+	}
 };
 
 int GeometryTestUtils::execute(const SString header, int argc, char *argv[],
-	void (*test)(Model &, const double))
+	void(*test)(Model &, const double))
 {
 	LoggerToStdout messages_to_stdout(LoggerBase::Enable); //comment this object out to mute error/warning messages
 	StdioFileSystem_autoselect stdiofilesys;
 	PreconfiguredGenetics genetics;
-	
+
 	srand(time(NULL));
 
@@ -202,5 +202,5 @@
 		return executeTestUsingLoadedModel(argv[2], argv[3], invoker);
 	}
-	
+
 	if ((argc == 3) && (strcmp("-c", argv[1]) == 0) && isdigit(argv[2][0]))
 	{
@@ -209,5 +209,5 @@
 		return executeTestUsingRandomModel(-1, invoker);
 	}
-	
+
 	if ((argc == 4) && (strcmp("-c", argv[1]) == 0) && isdigit(argv[2][0]) && isdigit(argv[3][0]))
 	{
@@ -217,5 +217,5 @@
 		return executeTestUsingRandomModel(shape, invoker);
 	}
-	
+
 	fprintf(stderr,
 		"%s\n\n"
@@ -235,9 +235,9 @@
 {
 	Part *part = model.addNewPart(Part::SHAPE_ELLIPSOID);
-	
+
 	part->p = Pt3D(0);
 	part->scale = Pt3D(0.1);
 	part->vcolor = Pt3D(1.0, 0.0, 1.0);
-	
+
 	addAxesToModel(Pt3D(0.5), Orient(Orient_1), Pt3D(0.0), model);
 }
@@ -247,9 +247,9 @@
 	Part *anchor = model.getPart(0);
 	Part *part = model.addNewPart(Part::SHAPE_ELLIPSOID);
-	
+
 	part->p = Pt3D(markerLocation);
 	part->scale = Pt3D(0.05);
 	part->vcolor = Pt3D(1.0, 1.0, 0.0);
-	
+
 	model.addNewJoint(anchor, part, Joint::SHAPE_FIXED);
 }
@@ -260,5 +260,5 @@
 	Part *anchor = model.getPart(0);
 	Part *part;
-	
+
 	part = model.addNewPart(Part::SHAPE_CUBOID);
 	part->scale = Pt3D(sizes.x, 0.05, 0.05);
@@ -267,5 +267,5 @@
 	part->vcolor = Pt3D(1.0, 0.0, 0.0);
 	model.addNewJoint(anchor, part, Joint::SHAPE_FIXED);
-	
+
 	part = model.addNewPart(Part::SHAPE_CUBOID);
 	part->scale = Pt3D(0.05, sizes.y, 0.05);
@@ -274,5 +274,5 @@
 	part->vcolor = Pt3D(0.0, 1.0, 0.0);
 	model.addNewJoint(anchor, part, Joint::SHAPE_FIXED);
-	
+
 	part = model.addNewPart(Part::SHAPE_CUBOID);
 	part->scale = Pt3D(0.05, 0.05, sizes.z);
@@ -287,7 +287,7 @@
 	Part *targetAnchor = target.getPart(0);
 	Part *sourceAnchor = source.getPart(0);
-	
+
 	target.moveElementsFrom(source);
-	
+
 	target.addNewJoint(targetAnchor, sourceAnchor, Joint::SHAPE_FIXED);
 }
@@ -295,5 +295,5 @@
 double frand(double from, double width)
 {
-	return from + width * ((rand()%10000) / 10000.0);
+	return from + width * ((rand() % 10000) / 10000.0);
 }
 