Index: /cpp/frams/genetics/f1/conv_f1.cpp
===================================================================
--- /cpp/frams/genetics/f1/conv_f1.cpp	(revision 742)
+++ /cpp/frams/genetics/f1/conv_f1.cpp	(revision 743)
@@ -454,5 +454,5 @@
 	else if ((i = last_f1_neuro->extraProperties().findIdn(begin, colon - begin)) >= 0)
 	{
-		last_f1_neuro->extraProperties().set(i, colon + 1);
+		last_f1_neuro->extraProperties().setFromString(i, colon + 1);
 	}
 	else if (isupper(begin[0]) || strchr("*|@", begin[0]))
Index: /cpp/frams/genetics/oper_fx.cpp
===================================================================
--- /cpp/frams/genetics/oper_fx.cpp	(revision 742)
+++ /cpp/frams/genetics/oper_fx.cpp	(revision 743)
@@ -50,5 +50,5 @@
 	{
 		double _mn = 0, _mx = 1, _def = 0.5;
-		defined = p->getMinMax(i, _mn, _mx, _def);
+		defined = p->getMinMaxDouble(i, _mn, _mx, _def);
 		if (defined == 1) _mx = _mn + 1.0;
 		if (_mx < _mn && defined == 3) _mn = _mx = _def; //only default was defined, let's assume min=max=default
@@ -59,5 +59,5 @@
 	{
 		paInt _mn = 0, _mx = 1, _def = 0;
-		defined = p->getMinMax(i, _mn, _mx, _def);
+		defined = p->getMinMaxInt(i, _mn, _mx, _def);
 		if (defined == 1) _mx = _mn + 1;
 		if (_mx < _mn && defined == 3) _mn = _mx = _def; //only default was defined, let's assume min=max=default
Index: /cpp/frams/model/modelparts.cpp
===================================================================
--- /cpp/frams/model/modelparts.cpp	(revision 742)
+++ /cpp/frams/model/modelparts.cpp	(revision 743)
@@ -180,5 +180,5 @@
 			if (i) t += "\n";
 			t += "   "; t += p.name(i); t += " ("; t += p.id(i); t += ") ";
-			t += p.describeType(i);
+			t += p.friendlyTypeDescr(i);
 			if (h = p.help(i)) if (*h) { t += " - "; t += h; }
 		}
Index: /cpp/frams/param/param.cpp
===================================================================
--- /cpp/frams/param/param.cpp	(revision 742)
+++ /cpp/frams/param/param.cpp	(revision 743)
@@ -74,20 +74,20 @@
 }
 
-int ParamInterface::getMinMax(int prop, paInt& minumum, paInt& maximum, paInt &def)
-{
-	return getMinMax(type(prop), minumum, maximum, def);
-}
-
-int ParamInterface::getMinMax(int prop, double& minumum, double& maximum, double& def)
-{
-	return getMinMax(type(prop), minumum, maximum, def);
-}
-
-int ParamInterface::getMinMax(int prop, int& minumum, int& maximum, SString& def)
-{
-	return getMinMax(type(prop), minumum, maximum, def);
-}
-
-int ParamInterface::getMinMax(const char* t, paInt& minumum, paInt& maximum, paInt &def)
+int ParamInterface::getMinMaxInt(int prop, paInt& minumum, paInt& maximum, paInt &def)
+{
+	return getMinMaxIntFromTypeDef(type(prop), minumum, maximum, def);
+}
+
+int ParamInterface::getMinMaxDouble(int prop, double& minumum, double& maximum, double& def)
+{
+	return getMinMaxDoubleFromTypeDef(type(prop), minumum, maximum, def);
+}
+
+int ParamInterface::getMinMaxString(int prop, int& minumum, int& maximum, SString& def)
+{
+	return getMinMaxStringFromTypeDef(type(prop), minumum, maximum, def);
+}
+
+int ParamInterface::getMinMaxIntFromTypeDef(const char* t, paInt& minumum, paInt& maximum, paInt &def)
 {
 	while (*t) if (*t == ' ') break; else t++;
@@ -95,5 +95,5 @@
 }
 
-int ParamInterface::getMinMax(const char* t, double& minumum, double& maximum, double& def)
+int ParamInterface::getMinMaxDoubleFromTypeDef(const char* t, double& minumum, double& maximum, double& def)
 {
 	while (*t) if (*t == ' ') break; else t++;
@@ -101,5 +101,5 @@
 }
 
-int ParamInterface::getMinMax(const char* t, int& minumum, int& maximum, SString& def)
+int ParamInterface::getMinMaxStringFromTypeDef(const char* t, int& minumum, int& maximum, SString& def)
 {
 	while (*t) if (*t == ' ') break; else t++;
@@ -154,5 +154,5 @@
 	{
 		double mn = 0, mx = 0, def = 0;
-		if (getMinMax(t, mn, mx, def) < 3) def = mn;
+		if (getMinMaxDoubleFromTypeDef(t, mn, mx, def) < 3) def = mn;
 		setDouble(i, def);
 	}
@@ -161,5 +161,5 @@
 	{
 		paInt mn = 0, mx = 0, def = 0;
-		if (getMinMax(t, mn, mx, def) < 3) def = mn;
+		if (getMinMaxIntFromTypeDef(t, mn, mx, def) < 3) def = mn;
 		setInt(i, def);
 	}
@@ -168,5 +168,5 @@
 	{
 		int mn, mx; SString def;
-		getMinMax(t, mn, mx, def);
+		getMinMaxStringFromTypeDef(t, mn, mx, def);
 		if (*t == 's')
 			setString(i, def);
@@ -191,5 +191,5 @@
 	{
 		double mn = 0, mx = 0, def = 0;
-		getMinMax(t, mn, mx, def);
+		getMinMaxDoubleFromTypeDef(t, mn, mx, def);
 		setDouble(i, mn);
 	}
@@ -198,9 +198,9 @@
 	{
 		paInt mn = 0, mx = 0, def = 0;
-		getMinMax(t, mn, mx, def);
+		getMinMaxIntFromTypeDef(t, mn, mx, def);
 		setInt(i, mn);
 	}
 		break;
-	default: set(i, "");
+	default: setFromString(i, "", false);
 	}
 }
@@ -214,5 +214,5 @@
 	{
 		double mn = 0, mx = 0, def = 0;
-		getMinMax(t, mn, mx, def);
+		getMinMaxDoubleFromTypeDef(t, mn, mx, def);
 		setDouble(i, mx);
 	}
@@ -221,9 +221,9 @@
 	{
 		paInt mn = 0, mx = 0, def = 0;
-		getMinMax(t, mn, mx, def);
+		getMinMaxIntFromTypeDef(t, mn, mx, def);
 		setInt(i, mx);
 	}
 		break;
-	default: set(i, "");
+	default: setFromString(i, "", false);
 	}
 }
@@ -549,5 +549,5 @@
 					if (options.linenum && (flags(i)&PARAM_LINECOMMENT))
 						s = SString::sprintf("@file %s\n@line %d\n", f->VgetPath(), *options.linenum + 1) + s;
-					set(i, s.c_str());
+					setFromString(i, s.c_str(), false);
 					if (options.linenum)
 						(*options.linenum) += lfcount;
@@ -555,5 +555,5 @@
 				else
 				{
-					set(i, p0 + p_len + 1);
+					setFromString(i, p0 + p_len + 1, false);
 				}
 				fields_loaded++;
@@ -644,5 +644,5 @@
 }
 
-int ParamInterface::setInt(int i, const char* str, bool strict)
+int ParamInterface::setIntFromString(int i, const char* str, bool strict)
 {
 	paInt value;
@@ -650,5 +650,5 @@
 	{
 		paInt mn, mx, def;
-		if (getMinMax(i, mn, mx, def) >= 3)
+		if (getMinMaxInt(i, mn, mx, def) >= 3)
 			return setInt(i, def) | PSET_PARSEFAILED;
 		else
@@ -659,5 +659,5 @@
 }
 
-int ParamInterface::setDouble(int i, const char* str)
+int ParamInterface::setDoubleFromString(int i, const char* str)
 {
 	double value;
@@ -665,5 +665,5 @@
 	{
 		double mn, mx, def;
-		if (getMinMax(i, mn, mx, def) >= 3)
+		if (getMinMaxDouble(i, mn, mx, def) >= 3)
 			return setDouble(i, def) | PSET_PARSEFAILED;
 		else
@@ -688,5 +688,5 @@
 			}
 			else
-				return setInt(i, v.getString().c_str());
+				return setIntFromString(i, v.getString().c_str(), false);
 		}
 	case 'f':
@@ -700,5 +700,5 @@
 			}
 			else
-				return setDouble(i, v.getString().c_str());
+				return setDoubleFromString(i, v.getString().c_str());
 		}
 	case 's': { SString t = v.getString(); return setString(i, t); }
@@ -715,11 +715,11 @@
 }
 
-int ParamInterface::set(int i, const char *v, bool strict)
+int ParamInterface::setFromString(int i, const char *v, bool strict)
 {
 	char typ = type(i)[0];
 	switch (typ)
 	{
-	case 'd': return setInt(i, v, strict);
-	case 'f': return setDouble(i, v);
+	case 'd': return setIntFromString(i, v, strict);
+	case 'f': return setDoubleFromString(i, v);
 	case 's': { SString t(v); return setString(i, t); }
 	case 'x': case 'o':
@@ -760,5 +760,5 @@
 		paInt mn, mx, def;
 		int value = getInt(i);
-		if (getMinMax(t, mn, mx, def) >= 2)
+		if (getMinMaxIntFromTypeDef(t, mn, mx, def) >= 2)
 		{
 			if (value > mx)
@@ -801,8 +801,8 @@
 	{
 	case 'd':
-	{paInt a, b, c; if (getMinMax(t, a, b, c) == 1) return false; }
+	{paInt a, b, c; if (getMinMaxIntFromTypeDef(t, a, b, c) == 1) return false; }
 		break;
 	case 'f':
-	{double a, b, c; if (getMinMax(t, a, b, c) == 1) return false; }
+	{double a, b, c; if (getMinMaxDoubleFromTypeDef(t, a, b, c) == 1) return false; }
 		break;
 	}
@@ -810,5 +810,5 @@
 }
 
-SString ParamInterface::describeType(const char* type)
+SString ParamInterface::friendlyTypeDescrFromTypeDef(const char* type)
 {
 	SString t;
@@ -816,11 +816,11 @@
 	{
 	case 'd': t += "integer";
-	{paInt a, b, c; int n = getMinMax(type, a, b, c); if ((n >= 2) && (b >= a)) t += SString::sprintf(" %d..%d", a, b); if (n >= 3) t += SString::sprintf(" (default %d)", c); }
+	{paInt a, b, c; int n = getMinMaxIntFromTypeDef(type, a, b, c); if ((n >= 2) && (b >= a)) t += SString::sprintf(" %d..%d", a, b); if (n >= 3) t += SString::sprintf(" (default %d)", c); }
 		break;
 	case 'f': t += "float";
-	{double a, b, c; int n = getMinMax(type, a, b, c); if ((n >= 2) && (b >= a)) t += SString::sprintf(" %g..%g", a, b); if (n >= 3) t += SString::sprintf(" (default %g)", c); }
+	{double a, b, c; int n = getMinMaxDoubleFromTypeDef(type, a, b, c); if ((n >= 2) && (b >= a)) t += SString::sprintf(" %g..%g", a, b); if (n >= 3) t += SString::sprintf(" (default %g)", c); }
 		break;
 	case 's': t += "string";
-	{int a, b; SString c; int n = getMinMax(type, a, b, c); if ((n >= 2) && (b > 0)) t += SString::sprintf(", max %d chars", b); if (n >= 3) t += SString::sprintf(" (default \"%s\")", c.c_str()); }
+	{int a, b; SString c; int n = getMinMaxStringFromTypeDef(type, a, b, c); if ((n >= 2) && (b > 0)) t += SString::sprintf(", max %d chars", b); if (n >= 3) t += SString::sprintf(" (default \"%s\")", c.c_str()); }
 		break;
 	case 'x': t += "untyped value"; break;
@@ -980,5 +980,5 @@
 	paInt mn = 0, mx = 0, de = 0;
 	int result = 0;
-	if (getMinMax(pe->type, mn, mx, de) >= 2)
+	if (getMinMaxIntFromTypeDef(pe->type, mn, mx, de) >= 2)
 		if (mn <= mx) // else if mn>mx then the min/max constraint makes no sense and there is no checking
 		{
@@ -1014,5 +1014,5 @@
 	double mn = 0, mx = 0, de = 0;
 	int result = 0;
-	if (getMinMax(pe->type, mn, mx, de) >= 2)
+	if (getMinMaxDoubleFromTypeDef(pe->type, mn, mx, de) >= 2)
 		if (mn <= mx) // else if mn>mx then the min/max constraint makes no sense and there is no checking
 		{
@@ -1279,5 +1279,5 @@
 			remember = *valstop;
 			*(char*)valstop = 0;
-			ret = set(i, value, true);
+			ret = setFromString(i, value, true);
 			fields_loaded++;
 			if (ret&(PSET_HITMAX | PSET_HITMIN))
Index: /cpp/frams/param/param.h
===================================================================
--- /cpp/frams/param/param.h	(revision 742)
+++ /cpp/frams/param/param.h	(revision 743)
@@ -118,6 +118,6 @@
 	ExtValue getById(const char* prop);
 
-	int setInt(int i, const char* str, bool strict = false);
-	int setDouble(int i, const char* str);
+	int setIntFromString(int i, const char* str, bool strict = false);
+	int setDoubleFromString(int i, const char* str);
 	virtual int setInt(int, paInt) = 0;		///< set long value, you can only use this for "d" type prop
 	virtual int setDouble(int, double) = 0;	///< set double value, you can only use this for "f" type prop
@@ -128,5 +128,5 @@
 	int set(int, const ExtValue &);///< most universal set, can be used for every datatype
 
-	int set(int, const char*, bool strict = false);		///< oldstyle set, can convert string to long or double
+	int setFromString(int, const char*, bool strict = false);		///< oldstyle set, can convert string to long or double
 
 	int setIntById(const char* prop, paInt);///< set long value, you can only use this for "d" type prop
@@ -139,12 +139,12 @@
 	/** get valid minimum, maximum and default value for property 'prop'
 		@return 0 if min/max/def information is not available */
-	int getMinMax(int prop, paInt& minumum, paInt& maximum, paInt& def);
+	int getMinMaxInt(int prop, paInt& minumum, paInt& maximum, paInt& def);
 	/** get valid minimum, maximum and default value for property 'prop'
 		@return 0 if min/max/def information is not available */
-	int getMinMax(int prop, double& minumum, double& maximum, double& def);
-	int getMinMax(int prop, int& minumum, int& maximum, SString& def);
-	static int getMinMax(const char* type, paInt& minumum, paInt& maximum, paInt& def);
-	static int getMinMax(const char* type, double& minumum, double& maximum, double& def);
-	static int getMinMax(const char* type, int& minumum, int& maximum, SString& def);
+	int getMinMaxDouble(int prop, double& minumum, double& maximum, double& def);
+	int getMinMaxString(int prop, int& minumum, int& maximum, SString& def);
+	static int getMinMaxIntFromTypeDef(const char* type, paInt& minumum, paInt& maximum, paInt& def);
+	static int getMinMaxDoubleFromTypeDef(const char* type, double& minumum, double& maximum, double& def);
+	static int getMinMaxStringFromTypeDef(const char* type, int& minumum, int& maximum, SString& def);
 
 	virtual void setDefault();
@@ -156,6 +156,6 @@
 
 	/** return the human readable description of the given type */
-	static SString describeType(const char* type);
-	SString describeType(int i) { return describeType(type(i)); }
+	static SString friendlyTypeDescrFromTypeDef(const char* type);
+	SString friendlyTypeDescr(int i) { return friendlyTypeDescrFromTypeDef(type(i)); }
 
 	/** copy all property values from other ParamInterface object */