Index: /cpp/frams/_demos/loader_test_param.cpp
===================================================================
--- /cpp/frams/_demos/loader_test_param.cpp	(revision 744)
+++ /cpp/frams/_demos/loader_test_param.cpp	(revision 745)
@@ -51,5 +51,5 @@
 	{ "notchanged", 0, PARAM_READONLY, "Read only field", "d", FIELD(notchanged), }, // neither load() nor setDefault() can change this field
 	{ "notloaded", 0, PARAM_DONTLOAD, "Non-loadable field", "d", FIELD(notloaded), }, // load() does not change this field
-	{ "notsaved", 0, PARAM_DONTSAVE, "Non-saveable field", "d", FIELD(notsaved), }, // save() skips this field
+	{ "notsaved", 0, PARAM_DONTSAVE, "Non-saveable field", "d", FIELD(notsaved), }, // saveSingle/MultiLine() skips this field
 	{ 0, 0, 0, },
 };
@@ -102,5 +102,5 @@
 			fprintf(stderr, "type of 'x2' is: %s\n", data.x2.typeDescription().c_str());
 			fprintf(stderr, "-----\n\n");
-			param.save(&virt_stdout);
+			param.saveMultiLine(&virt_stdout);
 			break;
 
Index: /cpp/frams/_demos/multiline_f0_test.cpp
===================================================================
--- /cpp/frams/_demos/multiline_f0_test.cpp	(revision 744)
+++ /cpp/frams/_demos/multiline_f0_test.cpp	(revision 745)
@@ -39,5 +39,5 @@
 printf("Converted to f0:\n%s\n",m.getF0Geno().getGenes().c_str());
 
-printf("\nusing Param::save() to create the \"expanded\" form of the f0 genotype...\n(MultiParamLoader should be able to load this)");
+printf("\nusing Param::saveMultiLine() to create the \"expanded\" form of the f0 genotype...\n(MultiParamLoader should be able to load this)");
 
 StringFILE2 f;
@@ -50,5 +50,5 @@
 
 modelparam.select(&m);
-modelparam.save(&f,"m");
+modelparam.saveMultiLine(&f,"m");
 
 Part *p;
@@ -59,5 +59,5 @@
 	{
 	partparam.select(p);
-	partparam.save(&f,"p");
+	partparam.saveMultiLine(&f,"p");
 	}
 for (int i=0;j=(Joint*)m.getJoint(i);i++)
@@ -65,10 +65,10 @@
 	jointparam.select(j);
 	jointparam.setParamTab(j->usedelta?f0_joint_paramtab:f0_nodeltajoint_paramtab);
-	jointparam.save(&f,"j");
+	jointparam.saveMultiLine(&f,"j");
 	}
 for (int i=0;n=(Neuro*)m.getNeuro(i);i++)
 	{
 	neuroparam.select(n);
-	neuroparam.save(&f,"n");
+	neuroparam.saveMultiLine(&f,"n");
 	}
 for (int a=0;n=(Neuro*)m.getNeuro(a);a++)
@@ -83,5 +83,5 @@
 		nc.info=n->getInputInfo(b);
 		connparam.select(&nc);
-		connparam.save(&f,"c");
+		connparam.saveMultiLine(&f,"c");
 		}
 	}
@@ -107,5 +107,5 @@
 
 
-using Param::save() to create the "expanded" form of the f0 genotype...
+using Param::saveMultiLine() to create the "expanded" form of the f0 genotype...
 (MultiParamLoader should be able to load this)
 ============================
Index: /cpp/frams/_demos/saver_test_geno.cpp
===================================================================
--- /cpp/frams/_demos/saver_test_geno.cpp	(revision 744)
+++ /cpp/frams/_demos/saver_test_geno.cpp	(revision 745)
@@ -40,5 +40,5 @@
 			g.info = "Saved by saver_test_geno.cpp";
 			g.is_valid = 1;
-			p.save(f, "org");
+			p.saveMultiLine(f, "org");
 		}
 		delete f;
Index: /cpp/frams/param/param.cpp
===================================================================
--- /cpp/frams/param/param.cpp	(revision 744)
+++ /cpp/frams/param/param.cpp	(revision 745)
@@ -275,5 +275,5 @@
 }
 
-int ParamInterface::save(VirtFILE* f, const char* altname, bool force)
+int ParamInterface::saveMultiLine(VirtFILE* f, const char* altname, bool force)
 {
 	const char *p;
Index: /cpp/frams/param/param.h
===================================================================
--- /cpp/frams/param/param.h	(revision 744)
+++ /cpp/frams/param/param.h	(revision 745)
@@ -176,5 +176,5 @@
 	};
 
-	int save(VirtFILE*, const char* altname = NULL, bool force = 0);
+	int saveMultiLine(VirtFILE*, const char* altname = NULL, bool force = 0);
 	int saveprop(VirtFILE*, int i, const char* p, bool force = 0);
 
Index: /cpp/frams/param/paramobj.h
===================================================================
--- /cpp/frams/param/paramobj.h	(revision 744)
+++ /cpp/frams/param/paramobj.h	(revision 745)
@@ -47,5 +47,5 @@
 		void* obj2=ParamObject::makeObject(tab);
 		Param par(tab,obj);
-		par.set(...), par.get(...), par.load(...), par.save(...);
+		par.set(...), par.get(...), par.load(...), par.saveSingle/MultiLine(...);
 		par.select(obj);
 		par.select(obj2);