Index: cpp/frams/genetics/fn/conv_fn.cpp
===================================================================
--- cpp/frams/genetics/fn/conv_fn.cpp	(revision 747)
+++ cpp/frams/genetics/fn/conv_fn.cpp	(revision 752)
@@ -29,16 +29,16 @@
 vector<double> GenoConv_fn0::stringToVector(const char *input) //returns empty vector on error
 {
-	vector<double> output;
+	vector<double> empty;
 	ExtValue val;
 	const char* after_des = val.deserialize(input);
-	if (after_des == NULL) // deserialization failed
+	if (after_des == NULL) //deserialization failed
 	{
-		logPrintf("fn", "stringToVector", LOG_ERROR, "Unable to deserialize - expecting a vector of real values, got '%s'", input);
-		return output;
+		logPrintf("GenoConv_fn0", "stringToVector", LOG_ERROR, "Unable to deserialize - expecting a vector of real values, got '%s'", input);
+		return empty;
 	}
-	if (after_des[0] != '\0') // not everything was consumed
+	if (after_des[0] != '\0') //not everything was consumed
 	{
-		logPrintf("fn", "stringToVector", LOG_ERROR, "Extra characters after deserialized '%s'", input);
-		return output;
+		logPrintf("GenoConv_fn0", "stringToVector", LOG_ERROR, "Extra characters after deserialized '%s'", input);
+		return empty;
 	}
 
@@ -46,4 +46,5 @@
 	if (vec)
 	{
+		vector<double> output;
 		for (int i = 0; i < vec->data.size(); i++)
 		{
@@ -51,15 +52,17 @@
 			if (val == NULL)
 			{
-				logPrintf("fn", "stringToVector", LOG_ERROR, "Expecting a real value in a vector, got NULL");
+				logPrintf("GenoConv_fn0", "stringToVector", LOG_ERROR, "Expecting a real value in a vector, got NULL");
+				return empty;
 			}
 			else
 				output.push_back(val->getDouble());
 		}
+		return output;
 	}
 	else
 	{
-		logPrintf("fn", "stringToVector", LOG_ERROR, "Expecting a vector of real values, got '%s'", input);
+		logPrintf("GenoConv_fn0", "stringToVector", LOG_ERROR, "Expecting a vector of real values, got '%s'", input);
+		return empty;
 	}
-	return output;
 }
 
Index: cpp/frams/genetics/fn/oper_fn.cpp
===================================================================
--- cpp/frams/genetics/fn/oper_fn.cpp	(revision 747)
+++ cpp/frams/genetics/fn/oper_fn.cpp	(revision 752)
@@ -11,6 +11,9 @@
 static ParamEntry GENOfnparam_tab[] =
 {
-	{ "Genetics: fn", 1, 1, },
-	{ "fn_xover", 0, 0, "Inherited in linear mix crossover", "f 0.5 1.0 0.5", FIELD(xover_proportion), "0.5 => children are averaged parents.\n0.8 => children are only 20% different from parents.\n1.0 => each child is identical to one parent (no crossover).", },
+	{ "Genetics: fn", 1, 4, },
+	{ "fn_xover", 0, 0, "Inherited in linear mix crossover", "f 0.5 1.0 0.9", FIELD(xover_proportion), "0.5 => children are averaged parents.\n0.8 => children are only 20% different from parents.\n1.0 => each child is identical to one parent (no crossover).", },
+	{ "fn_mut_bound_low", 1, 0, "Lower bounds for mutation", "s 0 0 [-1.0]", FIELD(mut_bound_low), "A vector of lower bounds (one real value for each variable)", },
+	{ "fn_mut_bound_high", 1, 0, "Higher bounds for mutation", "s 0 0 [1.0]", FIELD(mut_bound_high), "A vector of higher bounds (one real value for each variable)", },
+	{ "fn_mut_stddev", 1, 0, "Standard deviations for mutation", "s 0 0 [0.1]", FIELD(mut_stddev), "A vector of standard deviations (one real value for each variable)", },
 	{ 0, },
 };
@@ -51,6 +54,15 @@
 	if (values.size() == 0)
 		return GENOPER_OPFAIL;
+	vector<double> bound_low = GenoConv_fn0::stringToVector(mut_bound_low.c_str());
+	vector<double> bound_high = GenoConv_fn0::stringToVector(mut_bound_high.c_str());
+	vector<double> stddev = GenoConv_fn0::stringToVector(mut_stddev.c_str());
+	if (bound_low.size() != bound_high.size() || bound_high.size() != stddev.size() || stddev.size() != values.size())
+	{
+		logPrintf("GenoOper_fn", "mutate", LOG_ERROR, "The solution vector, bound vectors, and standard deviation vectors must all have the same number of values");
+		return GENOPER_OPFAIL;
+	}
+
 	int which = randomN(values.size());
-	values[which] = GenoOperators::mutateCreep('f', values[which], -100, 100); //TODO precision 0.001 is forced!
+	values[which] = GenoOperators::mutateCreep('f', values[which], bound_low[which], bound_high[which], stddev[which], false);
 	string saved = GenoConv_fn0::vectorToString(values);
 	free(gene);
Index: cpp/frams/genetics/fn/oper_fn.h
===================================================================
--- cpp/frams/genetics/fn/oper_fn.h	(revision 747)
+++ cpp/frams/genetics/fn/oper_fn.h	(revision 752)
@@ -21,4 +21,5 @@
 
 	double xover_proportion;
+	SString mut_bound_low, mut_bound_high, mut_stddev;
 };
 